--[[ Notes: 
	1) To use OnUpdate functionalty you'll need to uncomment this and the function RepTracker_OnUpdate

	2) C_Timer.After(seconds, function() <Your function1() function2() end) can also be used like
		C_Timer.After(seconds, function1) without the () in the function

	3) "local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(StormwindRepID))" 
		where 3 starts at the third variable in the table

	4) This is an example of the full code from GetFactionInfo()
	"local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)"

	5) Preserved here just in case I need to use it later.
	"local factionID1 = select(6,GetWatchedFactionInfo())" 

	6) Known Bugs: In AV the rep for IF/Org isn't displayed correctly
					Zones with multiple reps aren't displaying correctly.
	
	To-do:
	
	Recode the chatframe functionality to always display the correct rep.
	]]--



	local addon_name, addon_data = ...
	local FactionIsHorde
	local FactionIsAlliance
	
	local core_frame = CreateFrame("Frame", addon_name .. "CoreFrame", UIParent)
	core_frame:RegisterEvent("ADDON_LOADED")
	core_frame:SetScript("OnUpdate", CoreFrame_OnUpdate)
	
	local function OnAddonLoaded(self)
		core_frame:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")
		core_frame:RegisterEvent("PLAYER_ENTERING_WORLD")
		core_frame:RegisterEvent("UPDATE_FACTION")
		core_frame:RegisterEvent("ZONE_CHANGED")
		core_frame:RegisterEvent("ZONE_CHANGED_INDOORS")
		core_frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
		core_frame:RegisterEvent("UPDATE_INSTANCE_INFO")
			--Used to determine the players faction.
		if UnitRace("player") == "Human" or UnitRace("player") == "Night Elf" or UnitRace("player") == "Gnome" or UnitRace("player") == "Dwarf" then
			FactionIsAlliance = 1
		else
			FactionIsHorde = 1
		end
	end
	
--	local function CoreFrame_OnUpdate()
--	end
	
	local function CoreFrame_OnEvent(self, event, ...)
		local args = {...}
	
	   if event == "ADDON_LOADED" then
			if args[1] == "RepTracker" then
				OnAddonLoaded()
			end
		end
	
		if event == "PLAYER_ENTERING_WORLD" then
			C_Timer.After(20,ZoneInstanceData)
		end
	
		if event == "UPDATE_FACTION" then
			--GrabCurrentFactionValues()
			--ZoneInstanceData()
		end
		if event == "ZONE_CHANGED" then
			C_Timer.After(5,ZoneInstanceData)
		end
		if event == "UPDATE_INSTANCE_INFO" then
			C_Timer.After(5,ZoneInstanceData)
		end
		if event == "ZONE_CHANGED_INDOORS" then
			C_Timer.After(5,ZoneInstanceData)
		end
		if event == "ZONE_CHANGED_NEW_AREA" then
			if PlayerInBattleground == 1 then
				C_Timer.After(5,ZoneInstanceData)
			end
		end
		if event == "CHAT_MSG_COMBAT_FACTION_CHANGE" then
			if UnitOnTaxi("player") == false then
				ZoneInstanceData()
				local CurrentZone = GetRealZoneText()
				local SubZone = GetSubZoneText()
				if CurrentZone == "Ahn'Qiraj" then
					--if SubZone == "Refuge Pointe" then
						SetWatchedFactionIndex(BroodofNozdormuRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(BroodofNozdormuRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue+42000).."/"..math.floor(topValue+42000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					--end
				end
				if CurrentZone == "Ruins of Ahn'Qiraj" then
					--if SubZone == "Refuge Pointe" then
						SetWatchedFactionIndex(CenarionCircleRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(CenarionCircleRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					--end
				end
				if CurrentZone == "Moonglade" then
					--if SubZone == "Refuge Pointe" then
						SetWatchedFactionIndex(CenarionCircleRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(CenarionCircleRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					--end
				end
				if CurrentZone == "Arathi Highlands" then
					if SubZone == "Refuge Pointe" then
						SetWatchedFactionIndex(TheLeagueOfArathorRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(TheLeagueOfArathorRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					end
				end
				if CurrentZone == "Ashenvale" then
					if SubZone == "Silverwing Grove" then
						SetWatchedFactionIndex(SilverwingSentinelsRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(SilverwingSentinelsRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					end
				end
				if CurrentZone == "Alterac Mountains" then
					if SubZone == "Growless Cave" or SubZone == "Gavin's Naze" then
						SetWatchedFactionIndex(StormpikeGuardRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(StormpikeGuardRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					end
				end
				if CurrentZone == "Stranglethorn Vale" then
					-- Do nothing.
					if SubZone == "Yojamba Isle" then
						SetWatchedFactionIndex(ZandalarTribeRepID)
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(ZandalarTribeRepID))
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					end
				end
				if CurrentZone == "Stormwind City" then
					if SubZone == "Stormwind Keep" then
						-- Do nothing.
					else
						SetWatchedFactionIndex(StormwindRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(StormwindRepID))
						--else
						--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					end
				end
				if CurrentZone == "Winterspring" then
						local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(TimbermawHoldRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Felwood" then
						local standingId, _, topValue, earnedValue = select(3, GetFactionInfo(TimbermawHoldRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Scholomance" then
						local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(ArgentDawnRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Stratholme" then
						local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(ArgentDawnRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Darnassus" then
					local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(DarnassusRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Searing Gorge" then
					local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(ThoriumBrotherhoodRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Silithus" then
					local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(CenarionCircleRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Zul'Gurub" then
					local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(ZandalarTribeRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Molten Core" then
					local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(HydraxianWaterlordsRepID))
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Alterac Valley" then
					--if StormpikeGuardRepID ~= nil then
						local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(StormpikeGuardRepID))
					--else
					--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(FrostwolfClanRepID)
					--end
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Arathi Basin" then
					--if TheLeagueOfArathorRepID ~= nil then
						local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(TheLeagueOfArathorRepID))
					--else
					--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(TheDefilersRepID)
					--end
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Warsong Gulch" then
					--if SilverwingSentinelsRepID ~= nil then
						local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(SilverwingSentinelsRepID))
					--else
					--	local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(WarsongOutridersRepID)
					--end
					if standingId == 0 then -- Unknown
						--Skip
					elseif standingId == 1 then -- Hated
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
					elseif standingId == 2 then -- Hostile
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
					elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
					elseif standingId == 4 then -- Neutral
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
					elseif standingId == 5 then -- Friendly
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
					elseif standingId == 6 then -- Honored
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
					elseif standingId == 7 then -- Revered
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
					elseif standingId == 8 then -- Exalted
						print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
					end
				end
				if CurrentZone == "Ironforge" then
					if SubZone == "Tinker Town" then
						SetWatchedFactionIndex(GnomereganExilesRepId)
					--if Ironforge ~= nil then
						local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(GnomereganExilesRepId))
					--else
					--	local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(WarsongOutridersRepID)
					--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					elseif SubZone == "Hall of Arms" then
						-- Do nothing.
					else
					SetWatchedFactionIndex(IronforgeRepID)
						--if Ironforge ~= nil then
							local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(IronforgeRepID))
						--else
						--	local standingId, _, topValue, earnedValue = select(3,GetFactionInfo(WarsongOutridersRepID)
						--end
						if standingId == 0 then -- Unknown
							--Skip
						elseif standingId == 1 then -- Hated
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-24000).."/"..math.floor(topValue-24000).." |cffFF3F40(Hated)|r")
						elseif standingId == 2 then -- Hostile
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-12000).."/"..math.floor(topValue-12000).." |cffFF3F40(Hostile)|r")
						elseif standingId == 3 then -- Unfriendly
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cffFF3F40(Unfriendly)|r")
						elseif standingId == 4 then -- Neutral
								print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue).."/"..math.floor(topValue).." |cffFFFF00(Neutral)|r")
						elseif standingId == 5 then -- Friendly
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-3000).."/"..math.floor(topValue-3000).." |cff008000(Friendly)|r")
						elseif standingId == 6 then -- Honored
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-9000).."/"..math.floor(topValue-9000).." |cff008000(Honored)|r")
						elseif standingId == 7 then -- Revered
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-21000).."/"..math.floor(topValue-21000).." |cff008000(Revered)|r")
						elseif standingId == 8 then -- Exalted
							print("|cff67BCFFThis reputation is now:|r "..math.floor(earnedValue-42000).."/"..math.floor(topValue-42000).." |cff008000(Exalted)|r")
						end
					end
				end
			end
		end
	end
	
	function ZoneInstanceData()
		local CurrentZone = GetRealZoneText()
		local SubZone = GetSubZoneText()
		GrabCurrentFactionValues()
		if UnitOnTaxi("player") == false then
			if CurrentZone == "Ahn'Qiraj" then
					--if SubZone == "Silverwing Grove" then
				--if TheLeagueOfArathorRepID ~= nil then
						local a = BroodofNozdormuRepID
				--else
				--	local a = TheDefilersRepID
				--end
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				--end
			end
			if CurrentZone == "Ruins of Ahn'Qiraj" then
					--if SubZone == "Silverwing Grove" then
				--if TheLeagueOfArathorRepID ~= nil then
						local a = CenarionCircleRepID
				--else
				--	local a = TheDefilersRepID
				--end
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				--end
			end
			if CurrentZone == "Moonglade" then
					--if SubZone == "Silverwing Grove" then
				--if TheLeagueOfArathorRepID ~= nil then
						local a = CenarionCircleRepID
				--else
				--	local a = TheDefilersRepID
				--end
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				--end
			end
			if CurrentZone == "Ashenvale" then
					if SubZone == "Silverwing Grove" then
				--if TheLeagueOfArathorRepID ~= nil then
						local a = SilverwingSentinelsRepID
				--else
				--	local a = TheDefilersRepID
				--end
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				end
			end
			if CurrentZone == "Arathi Highlands" then
					if SubZone == "Refuge Pointe" then
				--if TheLeagueOfArathorRepID ~= nil then
						local a = TheLeagueOfArathorRepID
				--else
				--	local a = TheDefilersRepID
				--end
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				end
			end
			if CurrentZone == "Alterac Mountains" then
					if SubZone == "The Headland" then
				--if TheLeagueOfArathorRepID ~= nil then
						local a = StormpikeGuardRepID
				--else
				--	local a = TheDefilersRepID
				--end
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				end
			end
			if CurrentZone == "Stranglethorn Vale" then
				-- Do nothing.
				if SubZone == "Yojamba Isle" then
					local a = ZandalarTribeRepID
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				end
			end
			if CurrentZone == "Scholomance" then
				local a = ArgentDawnRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Stratholme" then
				local a = ArgentDawnRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Silithus" then
			if RepTracker_GlobalTimerTracker == nil then
					local a = CenarionCircleRepID
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
					RepTracker_GlobalTimerTracker = 1
					C_Timer.After(20,RepTracker_GlobalTimerTrackerFunctionUpdate)
				end
			end
			if CurrentZone == "Zul'Gurub" then
				local a = ZandalarTribeRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Molten Core" then
				local a = HydraxianWaterlordsRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Alterac Valley" then
				--if StormpikeGuardRepID ~= nil then
					local a = StormpikeGuardRepID
				--else
				--	local a = FrostwolfClanRepID
				--end
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Arathi Basin" then
				--if TheLeagueOfArathorRepID ~= nil then
					local a = TheLeagueOfArathorRepID
				--else
				--	local a = TheDefilersRepID
				--end
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Warsong Gultch" then
				--if SilverwingSentinelsRepID ~= nil then
					local a = SilverwingSentinelsRepID
				--else
				--	local a = WarsongOutridersRepID
				--end
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Searing Gorge" then
				--if SilverwingSentinelsRepID ~= nil then
					local a = ThoriumBrotherhoodRepID
				--else
				--	local a = WarsongOutridersRepID
				--end
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Winterspring" then
				local a = TimbermawHoldRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Felwood" then
				local a = TimbermawHoldRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Darnassus" then
				local a = DarnassusRepID
				local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
				SetWatchedFactionIndex(a)
				if isWatched ~= true then
					if standingId <= 3 then
						print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
					elseif standingId == 4 then
						print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
					elseif standingId >= 5 then
						print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
					end
				end
			end
			if CurrentZone == "Stormwind City" then
				if RepTracker_GlobalTimerTracker == nil then
					local a = StormwindRepID
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
					RepTracker_GlobalTimerTracker = 1
					C_Timer.After(20,RepTracker_GlobalTimerTrackerFunctionUpdate)
				end
			end
			if CurrentZone == "Ironforge" then
				if SubZone == "Hall of Arms" then
					-- Do nothing.
				elseif SubZone == "Tinker Town" then
					local a = GnomereganExilesRepId
					local name, _, standingId, _, _, _, _, _, _, _, _, isWatched, _, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				elseif SubZone ~= "Tinker Town" then
					local a = IronforgeRepID
					local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild, factionID = GetFactionInfo(a)
					SetWatchedFactionIndex(a)
					if isWatched ~= true then
						if standingId <= 3 then
							print("|cff67BCFFWatched reputation changed to: |cffFF3F40"..name.."|r")
						elseif standingId == 4 then
							print("|cff67BCFFWatched reputation changed to: |cffFFFF00"..name.."|r")
						elseif standingId >= 5 then
							print("|cff67BCFFWatched reputation changed to: |cff008000"..name.."|r")
						end
					end
				end
			end
		end
	end
	
	function GrabCurrentFactionValues()
		local CurrentZone = GetRealZoneText()
		for factionIndex = 1, GetNumFactions() do
			local name = GetFactionInfo(factionIndex)
			if name == "Brood of Nozdormu" then
				BroodofNozdormuRepID = factionIndex
			end
			if name == "Cenarion Circle" then
				CenarionCircleRepID = factionIndex
			end
			if name == "Zandalar Tribe" then
				ZandalarTribeRepID = factionIndex
			end
			if name == "Hydraxian Waterlords" then
				HydraxianWaterlordsRepID = factionIndex
			end
			if name == "Thorium Brotherhood" then
				ThoriumBrotherhoodRepID = factionIndex
			end
			if FactionIsAlliance then
				if name == "Stormpike Guard" then
					StormpikeGuardRepID = factionIndex
				end
				if name == "The League of Arathor" then
					TheLeagueOfArathorRepID = factionIndex
				end
				if name == "Silverwing Sentinels" then
					SilverwingSentinelsRepID = factionIndex
				end
				if name == "Ironforge" then
					IronforgeRepID = factionIndex
				end
				if name == "Darnassus" then
					DarnassusRepID = factionIndex
				end
				if name == "Gnomeregan Exiles" then
					GnomereganExilesRepId = factionIndex
				end
				if name == "Stormwind" then
					StormwindRepID = factionIndex
				end
			end
			if FactionIsHorde then
				if name == "The Defilers" then
					TheDefilersRepID = factionIndex
				end
				if name == "Frostwolf Clan" then
					FrostwolfClanRepID = factionIndex
				end
				if name == "Warsong Outriders" then
					WarsongOutridersRepID = factionIndex
				end
			end
			if name == "Timbermaw Hold" then
				TimbermawHoldRepID = factionIndex
			end
			if name == "Argent Dawn" then
				ArgentDawnRepID = factionIndex
			end
		end
	end
	
function PlayerInBattleground()
	local CurrentZone = GetRealZoneText()
	if CurrentZone == "Arathi Basin" or "Alterac Valley" or "Warsong Gultch" then
		return 1
	else
		return 0
	end
end
	
function RepTracker_GlobalTimerTrackerFunctionUpdate()
	RepTracker_GlobalTimerTracker = nil
end
	
	--core_frame:SetScript("OnUpdate", CoreFrame_OnUpdate)
	core_frame:SetScript("OnEvent", CoreFrame_OnEvent)